#include <iostream>
#include <fstream>
#include <stdlib.h>
using namespace std;

const int MAXNUM = 100;
const int MAXL = 50;

enum Ruolo {PORTIERE, DIFENSORE, CENTROCAMPISTA, ATTACCANTE};

struct Data {
  int giorno;
  int mese;
  int anno;
};

struct Giocatore {
  char nome[MAXL];
  char cognome[MAXL];
  Ruolo ru;
  Data sca;
  char squadra[MAXL];
  double quot;
};

struct ArchivioGio {
  Giocatore gio[MAXNUM];
  int numGio;
};

double quoMedia(const ArchivioGio* pa, Ruolo r); 
int inScadenza(const ArchivioGio* pa, Data d, Giocatore vet[]);
void quanti(const ArchivioGio* pa, int q[4]);
void salvaOrd(const ArchivioGio* pa, const char nf[]);
int elimina(ArchivioGio* pa, const char s[]);

void ins(ArchivioGio* pa, char n[], char c[], int g, int m, int a, Ruolo r, char s[], double qu) {
  int i = pa->numGio;
  strcpy(pa->gio[i].nome, n);
  strcpy(pa->gio[i].cognome, c);
  pa->gio[i].sca.giorno = g;
  pa->gio[i].sca.mese = m;
  pa->gio[i].sca.anno = a;
  pa->gio[i].ru = r;
  strcpy(pa->gio[i].squadra, s);
  pa->gio[i].quot = qu;
  pa->numGio++;
}

void stampaGio(Giocatore g) {
  cout << g.nome << " " << g.cognome << ", " << g.squadra << ", ";
  switch(g.ru) {
    case PORTIERE: 
      cout << "Port., ";
      break;
    case DIFENSORE:
      cout << "Difens., ";
      break;
    case CENTROCAMPISTA:
      cout << "Centroc., ";
      break;
    case ATTACCANTE:
      cout << "Attacc., ";
      break;
  }
  cout << g.sca.giorno << "/" << g.sca.mese << "/" << g.sca.anno << ", ";
  cout << g.quot << endl; 
}

void stampaArc(ArchivioGio* pa) {
  for(int i=0; i<pa->numGio; i++)
    stampaGio(pa->gio[i]);
  cout << endl;
}

int main(){
  ArchivioGio ag;
  ag.numGio = 0;
  ins(&ag, "Marco", "Materazzi", 23, 11, 2008, DIFENSORE, "Inter", 28.3);
  ins(&ag, "Andrea", "Pirlo", 2, 4, 2009, CENTROCAMPISTA, "Milan", 34.0);
  ins(&ag, "Zinedine", "Zidane", 3, 8, 2007, ATTACCANTE, "Real Madrid", 21.0);
  ins(&ag, "Gigi", "Buffon", 3, 7, 2009, PORTIERE, "Juventus", 38.3);
  ins(&ag, "Luca", "Toni", 10, 2, 2008, ATTACCANTE, "Fiorentina", 27.5);
  ins(&ag, "Daniele", "De Rossi", 19, 9, 2007, CENTROCAMPISTA, "Roma", 25.6);
  ins(&ag, "Fabio", "Cannavaro", 25, 4, 2008, DIFENSORE, "Juventus", 39.4);
  ins(&ag, "Fabio", "Grosso", 5, 9, 2010, DIFENSORE, "Inter", 30.4);
  ins(&ag, "Rino", "Gattuso", 20, 1, 2010, CENTROCAMPISTA, "Milan", 33.9);
  ins(&ag, "Gianluca", "Zambrotta", 1, 2, 2010, DIFENSORE, "Juventus", 38.0);
  ins(&ag, "David", "Beckham", 15, 6, 2009, CENTROCAMPISTA, "Real Madrid", 38.0);
  
  cout << "Stato iniziale dell'archivio" << endl;
  stampaArc(&ag);
  system("PAUSE");
    
  float im = quoMedia(&ag, DIFENSORE);
  cout << "Quotazione media dei difensori: " << im << endl;
  im = quoMedia(&ag, CENTROCAMPISTA);
  cout << "Quotazione media dei centrocampisti: " << im << endl;
  cout << endl;
  system("PAUSE");
   
  cout << "Contratti in scadenza prima del 1/1/2009:" << endl; 
  Data dd;
  dd.giorno = 1; dd.mese = 1; dd.anno = 2009;
  Giocatore vet[MAXNUM];
  int n = inScadenza(&ag, dd, vet);
  for(int i=0; i<n; i++)
    stampaGio(vet[i]);
  cout << "\nContratti in scadenza prima del 1/1/2008:" << endl; 
  dd.giorno = 1; dd.mese = 1; dd.anno = 2008;
  n = inScadenza(&ag, dd, vet);
  for(int i=0; i<n; i++)
    stampaGio(vet[i]);
  system("PAUSE");

  
  int qqq[4];
  quanti(&ag, qqq); 
  cout << "\nCi sono:\n" << qqq[0] << " portieri\n" << qqq[1] << " difensori\n" 
       << qqq[2] << " centrocampisti\n" << qqq[3] << " attaccanti" << endl;
  system("PAUSE");
  
  char* nf = "dati.txt"; 
  cout << "\nChiamo salvaOrd() per salvare i dati ordinati nel file " << nf << endl;
  salvaOrd(&ag, nf);
  cout << "Contenuto del file:" << endl;
  system("type dati.txt");
  system("PAUSE");

  cout << "\nChiamo la funzione elimina() con parametro \"Real Madrid\":" << endl;
  n = elimina(&ag, "Real Madrid");
  cout << "Ho eliminato " << n << " giocatori" << endl;
  cout << "Adesso il contenuto dell'archivio e':" << endl;
  stampaArc(&ag);
  system("PAUSE");
  
}
