#include <iostream>
#include <fstream>
#include <stdlib.h>
using namespace std;

const int MAXNUM = 100;
const int MAXL = 50;

enum Ruolo {PORTIERE, DIFENSORE, CENTROCAMPISTA, ATTACCANTE};

struct Data {
  int giorno;
  int mese;
  int anno;
};

struct Giocatore {
  char nome[MAXL];
  char cognome[MAXL];
  Ruolo ru;
  Data sca;
  char squadra[MAXL];
  double quot;
};

struct ArchivioGio {
  Giocatore gio[MAXNUM];
  int numGio;
};

double quoMedia(const ArchivioGio* pa, Ruolo r) {
  double im = 0;
  int conta = 0;
  for(int i=0; i<pa->numGio; i++)
    if(pa->gio[i].ru == r) {
      im += pa->gio[i].quot;
      conta++;
    }
  if(conta != 0) 
    im = im/conta;
  return im;
}

int confronta(const Data d1, const Data d2) {
  if(d1.anno != d2.anno) return d1.anno - d2.anno;
  if(d1.mese != d2.mese) return d1.mese - d2.mese;
  return d1.giorno - d2.giorno;
}


int inScadenza(const ArchivioGio* pa, Data d, Giocatore vet[]) {
  int conta = 0;
  for(int i=0; i<pa->numGio; i++)
    if(confronta(pa->gio[i].sca, d) < 0)
      vet[conta++] = pa->gio[i];
  return conta;
}

void quanti(const ArchivioGio* pa, int q[4]) {
  for(int i=0; i<4; i++) 
    q[i] = 0;
  for(int i=0; i<pa->numGio; i++)
    q[pa->gio[i].ru] ++;
}

void scambia(Giocatore v[], int x, int y){
  Giocatore tmp;
  tmp = v[x];
  v[x] = v[y];
  v[y] = tmp;
}

void ordina(Giocatore v[], int n) {
  bool ordinato = false;
  for(int i=0; i<n-1 && !ordinato; i++) {
    ordinato = true;
    for(int j = n-1; j>=i+1; j--)
      if(v[j].quot > v[j-1].quot) {
        scambia(v, j, j-1);
        ordinato = false;
      }
  }
}

void salvaOrd(const ArchivioGio* pa, const char nf[]){
  Giocatore vvv[MAXNUM];
  for(int i=0; i<pa->numGio; i++)
    vvv[i] = pa->gio[i]; 
  ordina(vvv, pa->numGio);
  fstream ff;
  ff.open(nf, ios::out);
  if(!ff){
    cerr << "Errore nell'apertura del file" << endl;
    exit(1);
  }
  for(int i=0; i<pa->numGio; i++)
    ff << vvv[i].nome << ", " << vvv[i].cognome << ", " << vvv[i].quot << endl;
}

int elimina(ArchivioGio* pa, const char s[]) {
  int conta = 0;
  for(int i=0; i<pa->numGio; i++)
    if(strcmp(pa->gio[i].squadra, s) == 0) {
      pa->gio[i] = pa->gio[pa->numGio-1];
      pa->numGio--; 
      conta++;
      i--;
    }
  return conta;
}
